/*
 * Numerische Integration
 */
# include <stdio.h>
# include <math.h>
# include "polynom.h"
                 /* Zeiger auf Funktion als Parameter*/
double trapezFormel
  ( double, double, int, double (*)( double));

int main()
{
  double a, b, ( *f)( double);/* Zeiger auf Funktion */
  int n, Wahl;
  printf( "Funktion? (1: Sin, 2: Cos, 3: Polynom)");
  scanf( "%d", &Wahl);
  switch ( Wahl)                  /* Adresszuweisung */
  { case 1: f = sin; break;    /* Standardfunktionen */
    case 2: f = cos; break;
    case 3: polynomEingabe();    /* Benutzerfunktion */
            f = polynom; break;
    default: printf( "Wahl unzulaessig!\n");
            return -1;
  }

  printf( "Intervallgrenzen (untere obere)? ");
  scanf( "%lf%lf", &a, &b);
  printf( "Anzahl der Teilintervalle? ");
  scanf( "%d", &n);
  printf( "Integralwert: %g\n",
           trapezFormel( a, b, n, f));

  if( Wahl == 3) polynomLoeschen();
  return 0;
}

/*
 * Integration
 */
double trapezFormel( double a, double b, int n,
                     double (*f)(double))
{
  double s, h; int i;
  h = ( b - a) / n; s = 0.5 * ( f( a) + f ( b));
  for ( i = 1; i < n; i++){ a += h; s += f( a);}
  return s * h;
}
